var NAVTREE =
[
  [ "GRASS Programmer's Manual", "index.html", [
    [ "GRASS 6 Programmer's Manual", "index.html", [
      [ "Principal library", "index.html#corelibs", null ],
      [ "Further libraries", "index.html#libs", null ],
      [ "Interfaces", "index.html#interfaces", null ],
      [ "GUI", "index.html#gui", null ],
      [ "File structure of GRASS Location", "index.html#location", null ]
    ] ],
    [ "GRASS wxPython-based GUI", "wxpythonlib.html", [
      [ "Background", "wxpythonlib.html#background", null ],
      [ "List of Modules and Classes", "wxpythonlib.html#classes", [
        [ "Core modules", "wxpythonlib.html#core", null ],
        [ "GUI core modules", "wxpythonlib.html#gui_core", null ],
        [ "Layer Manager", "wxpythonlib.html#lmgr", null ],
        [ "Map Display Window", "wxpythonlib.html#mapdisp", null ],
        [ "Welcome screen", "wxpythonlib.html#wscreen", null ],
        [ "Database Manager", "wxpythonlib.html#dbmgr", null ],
        [ "Georectifier", "wxpythonlib.html#gpc", null ],
        [ "Graphical Modeler", "wxpythonlib.html#gmodeler", null ],
        [ "Vector digitizer", "wxpythonlib.html#vdigit", null ],
        [ "3D view mode (wxNviz)", "wxpythonlib.html#wxnviz", null ],
        [ "Cartograpic Composer", "wxpythonlib.html#psmap", null ],
        [ "Location Wizard", "wxpythonlib.html#locWizard", null ],
        [ "Plotting modules", "wxpythonlib.html#plot", null ],
        [ "Other GUI modules", "wxpythonlib.html#other", null ]
      ] ],
      [ "Further Development", "wxpythonlib.html#devel", null ],
      [ "See also", "wxpythonlib.html#seeAlso", null ],
      [ "References", "wxpythonlib.html#refs", null ]
    ] ],
    [ "GRASS cluster analysis statistics Library", "clusterlib.html", [
      [ "Introduction to cluster analysis statistics Library", "clusterlib.html#clusterintro", null ]
    ] ],
    [ "GRASS DBMI DataBase Management Interface", "dbmilib.html", [
      [ "Introduction", "dbmilib.html#intro", null ],
      [ "DBMI library functions", "dbmilib.html#dbmifunc", null ],
      [ "DBMI BASE functions", "dbmilib.html#dbmi_base", null ],
      [ "DBMI CLIENT functions", "dbmilib.html#dbmi_client", null ],
      [ "DBMI DRIVER functions", "dbmilib.html#dbmi_driver", null ],
      [ "DBMI functions list (incomplete)", "dbmilib.html#dbmi_functions", [
        [ "DB alloc routines", "dbmilib.html#DB_alloc_routines", null ],
        [ "DB case routines", "dbmilib.html#DB_case_routines", null ],
        [ "DB column routines", "dbmilib.html#DB_column_routines", null ],
        [ "DB columnfmt routines", "dbmilib.html#DB_columnfmt_routines", null ],
        [ "DB connect routines", "dbmilib.html#DB_connect_routines", null ],
        [ "DB *cursor routines", "dbmilib.html#DB_cursor_routines", null ],
        [ "DB datetime routines", "dbmilib.html#DB_datetime_routines", null ],
        [ "DB zero routines", "dbmilib.html#DB_zero_routines", null ],
        [ "DB dbmscap routines", "dbmilib.html#DB_dbmscap_routines", null ],
        [ "DB default_name routines", "dbmilib.html#DB_default_name_routines", null ],
        [ "DB dirent routines", "dbmilib.html#DB_dirent_routines", null ],
        [ "DB error routines", "dbmilib.html#DB_error_routines", null ],
        [ "DB handle routines", "dbmilib.html#DB_handle_routines", null ],
        [ "DB index routines", "dbmilib.html#DB_index_routines", null ],
        [ "DB interval routines", "dbmilib.html#DB_interval_routines", null ],
        [ "DB isdir routines", "dbmilib.html#DB_isdir_routines", null ],
        [ "DB login routines", "dbmilib.html#DB_login_routines", null ],
        [ "DB ret_codes routines", "dbmilib.html#DB_ret_codes_routines", null ],
        [ "DB sqlCtype routines", "dbmilib.html#DB_sqlCtype_routines", null ],
        [ "DB sqltype routines", "dbmilib.html#DB_sqltype_routines", null ],
        [ "DB string routines", "dbmilib.html#DB_string_routines", null ],
        [ "DB strip routines", "dbmilib.html#DB_strip_routines", null ],
        [ "DB table routines", "dbmilib.html#DB_table_routines", null ],
        [ "DB token routines", "dbmilib.html#DB_token_routines", null ],
        [ "DB value routines", "dbmilib.html#DB_value_routines", null ],
        [ "DB valuefmt routines", "dbmilib.html#DB_valuefmt_routines", null ],
        [ "DB whoami routines", "dbmilib.html#DB_whoami_routines", null ],
        [ "DB xdr routines", "dbmilib.html#DB_xdr_routines", null ],
        [ "DB xdrchar *routines", "dbmilib.html#DB_xdrchar_routines", null ],
        [ "DB xdrcolumn routines", "dbmilib.html#DB_xdrcolumn_routines", null ],
        [ "DB xdrdatetime routines", "dbmilib.html#DB_xdrdatetime_routines", null ],
        [ "DB xdrdouble routines", "dbmilib.html#DB_xdrdouble_routines", null ],
        [ "DB xdrfloat routines", "dbmilib.html#DB_xdrfloat_routines", null ],
        [ "DB xdrhandle routines", "dbmilib.html#DB_xdrhandle_routines", null ],
        [ "DB xdrindex routines", "dbmilib.html#DB_xdrindex_routines", null ],
        [ "DB xdrint routines", "dbmilib.html#DB_xdrint_routines", null ],
        [ "DB xdrprocedure routines", "dbmilib.html#DB_xdrprocedure_routines", null ],
        [ "DB xdrshort routines", "dbmilib.html#DB_xdrshort_routines", null ],
        [ "DB xdrstring routines", "dbmilib.html#DB_xdrstring_routines", null ],
        [ "DB xdrtable routines", "dbmilib.html#DB_xdrtable_routines", null ],
        [ "DB xdrtoken routines", "dbmilib.html#DB_xdrtoken_routines", null ],
        [ "DB xdrvalue routines", "dbmilib.html#DB_xdrvalue_routines", null ],
        [ "DB c_add_col routines", "dbmilib.html#DB_c_add_col_routines", null ],
        [ "DB c_bindupdate routines", "dbmilib.html#DB_c_bindupdate_routines", null ],
        [ "DB c_close_cur routines", "dbmilib.html#DB_c_close_cur_routines", null ],
        [ "DB c_closedb routines", "dbmilib.html#DB_c_closedb_routines", null ],
        [ "DB c_create_idx routines", "dbmilib.html#DB_c_create_idx_routines", null ],
        [ "DB c_create_tab routines", "dbmilib.html#DB_c_create_tab_routines", null ],
        [ "DB c_createdb routines", "dbmilib.html#DB_c_createdb_routines", null ],
        [ "DB c_delete routines", "dbmilib.html#DB_c_delete_routines", null ],
        [ "DB c_deletedb routines", "dbmilib.html#DB_c_deletedb_routines", null ],
        [ "DB c_desc_table routines", "dbmilib.html#DB_c_desc_table_routines", null ],
        [ "DB c_drop_col routines", "dbmilib.html#DB_c_drop_col_routines", null ],
        [ "DB c_drop_index routines", "dbmilib.html#DB_c_drop_index_routines", null ],
        [ "DB c_drop_tab routines", "dbmilib.html#DB_c_drop_tab_routines", null ],
        [ "DB c_execute routines", "dbmilib.html#DB_c_execute_routines", null ],
        [ "DB c_fetch routines", "dbmilib.html#DB_c_fetch_routines", null ],
        [ "#db_routines DB c_finddb routines", "dbmilib.html#DB_c_find", null ],
        [ "DB c_insert routines", "dbmilib.html#DB_c_insert_routines", null ],
        [ "DB c_list_drivers routines", "dbmilib.html#DB_c_list_drivers_routines", null ],
        [ "DB c_list_idx routines", "dbmilib.html#DB_c_list_idx_routines", null ],
        [ "DB c_list_tabs routines", "dbmilib.html#DB_c_list_tabs_routines", null ],
        [ "DB c_listdb routines", "dbmilib.html#DB_c_listdb_routines", null ],
        [ "DB c_opendb routines", "dbmilib.html#DB_c_opendb_routines", null ],
        [ "DB c_openinsert routines", "dbmilib.html#DB_c_openinsert_routines", null ],
        [ "DB c_openselect routines", "dbmilib.html#DB_c_openselect_routines", null ],
        [ "DB c_openupdate routines", "dbmilib.html#DB_c_openupdate_routines", null ],
        [ "DB c_priv routines", "dbmilib.html#DB_c_priv_routines", null ],
        [ "DB c_rows routines", "dbmilib.html#DB_c_rows_routines", null ],
        [ "DB c_update routines", "dbmilib.html#DB_c_update_routines", null ],
        [ "DB c_version routines", "dbmilib.html#DB_c_version_routines", null ],
        [ "DB copy_tab routines", "dbmilib.html#DB_copy_tab_routines", null ],
        [ "DB db routines", "dbmilib.html#DB_db_routines", null ],
        [ "DB delete_tab routines", "dbmilib.html#DB_delete_tab_routines", null ],
        [ "DB printtab routines", "dbmilib.html#DB_printtab_routines", null ],
        [ "DB select routines", "dbmilib.html#DB_select_routines", null ],
        [ "DB shutdown routines", "dbmilib.html#DB_shutdown_routines", null ],
        [ "DB start routines", "dbmilib.html#DB_start_routines", null ],
        [ "DB d_add_col routines", "dbmilib.html#DB_d_add_col_routines", null ],
        [ "DB d_bindupdate routines", "dbmilib.html#DB_d_bindupdate_routines", null ],
        [ "DB d_close_cur routines", "dbmilib.html#DB_d_close_cur_routines", null ],
        [ "DB d_closedb routines", "dbmilib.html#DB_d_closedb_routines", null ],
        [ "DB d_create_idx routines", "dbmilib.html#DB_d_create_idx_routines", null ],
        [ "DB d_create_tab routines", "dbmilib.html#DB_d_create_tab_routines", null ],
        [ "DB d_createdb routines", "dbmilib.html#DB_d_createdb_routines", null ],
        [ "DB d_delete routines", "dbmilib.html#DB_d_delete_routines", null ],
        [ "DB d_deletedb routines", "dbmilib.html#DB_d_deletedb_routines", null ],
        [ "DB d_desc_table routines", "dbmilib.html#DB_d_desc_table_routines", null ],
        [ "DB d_drop_col routines", "dbmilib.html#DB_d_drop_col_routines", null ],
        [ "DB d_drop_index routines", "dbmilib.html#DB_d_drop_index_routines", null ],
        [ "DB d_drop_tab routines", "dbmilib.html#DB_d_drop_tab_routines", null ],
        [ "DB d_execute routines", "dbmilib.html#DB_d_execute_routines", null ],
        [ "DB d_fetch routines", "dbmilib.html#DB_d_fetch_routines", null ],
        [ "DB d_finddb routines", "dbmilib.html#DB_d_finddb_routines", null ],
        [ "DB d_insert routines", "dbmilib.html#DB_d_insert_routines", null ],
        [ "DB d_list_idx routines", "dbmilib.html#DB_d_list_idx_routines", null ],
        [ "DB d_list_tabs routines", "dbmilib.html#DB_d_list_tabs_routines", null ],
        [ "DB d_listdb routines", "dbmilib.html#DB_d_listdb_routines", null ],
        [ "DB d_mkdir routines", "dbmilib.html#DB_d_mkdir_routines", null ],
        [ "DB d_opendb routines", "dbmilib.html#DB_d_opendb_routines", null ],
        [ "DB d_openinsert routines", "dbmilib.html#DB_d_openinsert_routines", null ],
        [ "DB d_openselect routines", "dbmilib.html#DB_d_openselect_routines", null ],
        [ "DB d_openupdate routines", "dbmilib.html#DB_d_openupdate_routines", null ],
        [ "DB d_priv routines", "dbmilib.html#DB_d_priv_routines", null ],
        [ "DB d_rows routines", "dbmilib.html#DB_d_rows_routines", null ],
        [ "DB d_update routines", "dbmilib.html#DB_d_update_routines", null ],
        [ "DB d_version routines", "dbmilib.html#DB_d_version_routines", null ],
        [ "DB driver routines", "dbmilib.html#DB_driver_routines", null ],
        [ "DB driver_state routines", "dbmilib.html#DB_driver_state_routines", null ]
      ] ],
      [ "Contacts", "dbmilib.html#contacts", null ],
      [ "References", "dbmilib.html#references", null ],
      [ "See Also", "dbmilib.html#seealso", null ]
    ] ],
    [ "GRASS Display Library", "displaylib.html", [
      [ "Display Library", "displaylib.html#displayintro", null ]
    ] ],
    [ "GRASS Grid3D raster volume Library", "g3dlib.html", [
      [ "Grid3D raster volume Library", "g3dlib.html#g3dintro", null ],
      [ "Directory Structure", "g3dlib.html#Directory_Structure", null ],
      [ "Data File Format", "g3dlib.html#Data_File_Format", null ],
      [ "Transportability of data file", "g3dlib.html#Transportability_of_data_file", null ],
      [ "Tile Data NULL-values", "g3dlib.html#Tile_Data_NULL_values", null ],
      [ "Tile Data Compression", "g3dlib.html#Tile_Data_Compression", null ],
      [ "Tile Cache", "g3dlib.html#Tile_Cache", null ],
      [ "Header File", "g3dlib.html#Header_File", null ],
      [ "Region Structure", "g3dlib.html#Region_Structure", null ],
      [ "Windows", "g3dlib.html#Windows", null ],
      [ "Masks", "g3dlib.html#Masks", null ],
      [ "Include File", "g3dlib.html#Include_File", null ],
      [ "G3D Defaults", "g3dlib.html#G3D_Defaults", null ],
      [ "Cache Mode", "g3dlib.html#Cache_Mode", [
        [ "Limiting the maximum cache size", "g3dlib.html#Limiting_the_maximum_cache_size", null ],
        [ "Setting the cache size", "g3dlib.html#Setting_the_cache_size", null ]
      ] ],
      [ "Compression", "g3dlib.html#Compression", [
        [ "Toggling compression mode", "g3dlib.html#Toggling_compression_mode", null ],
        [ "Toggling RLE compression", "g3dlib.html#Toggling_RLE_compression", null ]
      ] ],
      [ "Setting the precision", "g3dlib.html#Setting_the_precision", null ],
      [ "Tiles", "g3dlib.html#Tiles", [
        [ "Setting the tile dimensions", "g3dlib.html#Setting_the_tile_dimensions", null ]
      ] ],
      [ "Setting the tile cell-value type", "g3dlib.html#Setting_the_tile_cell_value_type", null ],
      [ "Setting the window", "g3dlib.html#Setting_the_window", null ],
      [ "Setting the Units", "g3dlib.html#Setting_the_Units", null ],
      [ "Error Handling: Setting the error function", "g3dlib.html#Error_Handling", null ],
      [ "G3D Function Index", "g3dlib.html#G3D_Function_Index", [
        [ "Opening and Closing G3D Files", "g3dlib.html#Opening_and_Closing_G3D_Files", null ],
        [ "Reading and Writing Tiles", "g3dlib.html#Reading_and_Writing_Tiles", null ],
        [ "Reading and Writing Cells", "g3dlib.html#Reading_and_Writing_Cells", null ],
        [ "and Removing Tiles", "g3dlib.html#Loading_and_Removing_TilesLoading", null ],
        [ "Write Functions used in Cache Mode", "g3dlib.html#Write_Functions_used_in_Cache_Mode", null ],
        [ "and Unlocking Tiles, and Cycles", "g3dlib.html#Locking_and_Unlocking_Tiles_and_CyclesLocking", null ],
        [ "Reading Volumes", "g3dlib.html#Reading_Volumes", null ],
        [ "Allocating and Freeing Memory", "g3dlib.html#Allocating_and_Freeing_Memory", null ],
        [ "G3D Null Value Support", "g3dlib.html#G3D_Null_Value_Support", null ],
        [ "G3D Map Header Information", "g3dlib.html#G3D_Map_Header_Information", null ],
        [ "G3D Tile Math", "g3dlib.html#G3D_Tile_Math", null ],
        [ "G3D Range Support", "g3dlib.html#G3D_Range_Support", null ],
        [ "G3D Color Support", "g3dlib.html#G3D_Color_Support", null ],
        [ "G3D Categories Support", "g3dlib.html#G3D_Categories_Support", null ],
        [ "G3D History Support", "g3dlib.html#G3D_History_Support", null ],
        [ "G3D Mask Support", "g3dlib.html#G3D_Mask_Support", null ],
        [ "G3D Window Support", "g3dlib.html#G3D_Window_Support", null ],
        [ "G3D Region", "g3dlib.html#G3D_Region", null ],
        [ "Miscellaneous Functions", "g3dlib.html#Miscellaneous_Functions", null ]
      ] ],
      [ "Sample G3D Applications", "g3dlib.html#Sample_G3D_Applications", null ]
    ] ],
    [ "GRASS GIS Library", "gislib.html", "gislib" ],
    [ "GRASS Numerical math interface", "gmathlib.html", [
      [ "Numerical math interface with optional support of LAPACK/BLAS", "gmathlib.html#gmathintro", null ],
      [ "Implementation", "gmathlib.html#Implementation", null ],
      [ "matrix -matrix functions", "gmathlib.html#matrix_matrix_functions", null ],
      [ "Matrix-Vector functions", "gmathlib.html#matrix_Vector_functions", null ],
      [ "Vector-Vector functions", "gmathlib.html#Vector_Vector_functions", null ],
      [ "Notes", "gmathlib.html#Notes", null ],
      [ "Example", "gmathlib.html#Example", null ]
    ] ],
    [ "GRASS partial differential equations Library (GPDE)", "gpdelib.html", [
      [ "The Creation of a lineare equation systems", "gpdelib.html#PDE", [
        [ "Raster maps", "gpdelib.html#rastermaps", [
          [ "Higher level array functions", "gpdelib.html#highlevel", null ]
        ] ],
        [ "Volume maps", "gpdelib.html#g3dmaps", null ],
        [ "Entries in the linear equation system", "gpdelib.html#les", null ]
      ] ],
      [ "Available solvers", "gpdelib.html#solvers", [
        [ "Direct solvers", "gpdelib.html#direct_solvers", null ],
        [ "Iterative solvers", "gpdelib.html#iterative_solvers", null ]
      ] ],
      [ "Implemented PDE's", "gpdelib.html#available_pdes", null ],
      [ "Handling geometrical data", "gpdelib.html#geom_data", null ],
      [ "Mathematical tools", "gpdelib.html#mathtools", null ],
      [ "Calculating and managing gradient and vector field data", "gpdelib.html#gradient", null ]
    ] ],
    [ "GRASS Imagery Library", "imagerylib.html", [
      [ "Introduction to Imagery Library", "imagerylib.html#imageryintro", [
        [ "Group Processing", "imagerylib.html#Group_Processing", null ],
        [ "Prompting for a Group", "imagerylib.html#Prompting_for_a_Group", null ],
        [ "Finding Groups in the Database", "imagerylib.html#Finding_Groups_in_the_Database", null ],
        [ "REF File", "imagerylib.html#REF_File", null ],
        [ "TARGET File", "imagerylib.html#TARGET_File", null ],
        [ "POINTS File", "imagerylib.html#POINTS_File", null ],
        [ "Loading the Imagery Library", "imagerylib.html#Loading_the_Imagery_Library", null ]
      ] ],
      [ "Imagery Library Data Structures", "imagerylib.html#Imagery_Library_Data_Structures", [
        [ "struct Ref", "imagerylib.html#struct_Ref", null ],
        [ "struct Control_Points", "imagerylib.html#struct_Control_Points", null ]
      ] ]
    ] ],
    [ "GRASS Nviz Library", "nvizlib.html", [
      [ "Introduction to Nviz Library", "nvizlib.html#nvizintro", null ],
      [ "Functions", "nvizlib.html#Functions", [
        [ "Initialization", "nvizlib.html#nvizInit", null ],
        [ "Viewport settings", "nvizlib.html#NvizViewport", null ],
        [ "Draw map objects", "nvizlib.html#nvizDraw", null ],
        [ "Map objects manipulation", "nvizlib.html#nvizMapObj", null ],
        [ "Lights settings", "nvizlib.html#nvizLights", null ],
        [ "Clip planes manipulation", "nvizlib.html#nvizCplanes", null ],
        [ "Off-screen rendering", "nvizlib.html#nvizRender", null ]
      ] ]
    ] ],
    [ "GRASS openGL gsurf OGSF Library", "ogsflib.html", [
      [ "OGSF Library for OpenGL programming (gsurf)", "ogsflib.html#ogsfintro", [
        [ "Naming Conventions", "ogsflib.html#Naming_Conventions", null ]
      ] ],
      [ "Public function prototypes", "ogsflib.html#Public_function_prototypes_for_gsurf_Library", [
        [ "Initialization and positioning (GS)", "ogsflib.html#gs_init", null ],
        [ "Loading and manipulation of vector maps (GV)", "ogsflib.html#gv_vect", null ],
        [ "Loading and manipulation of point maps (GP)", "ogsflib.html#gp_points", null ],
        [ "Keyframe animation", "ogsflib.html#gk_keyframes", null ],
        [ "Loading and manipulation of volume maps (GVL)", "ogsflib.html#gvl_volume", null ],
        [ "Loading and manipulation of isosurfaces (GVL)", "ogsflib.html#gvl_volume_isosurf", null ],
        [ "Loading and manipulation of slices (GVL)", "ogsflib.html#gvl_volume_slice", null ],
        [ "Public include file gsurf.h", "ogsflib.html#gsurf_h", null ],
        [ "Public include file keyframe.h", "ogsflib.html#keyframe_h", null ],
        [ "Public color packing utility macros rgbpack.h", "ogsflib.html#rgbpack_h", null ],
        [ "Private types and defines gstypes.h", "ogsflib.html#gstypes_h", null ],
        [ "Private utilities gsget.h", "ogsflib.html#gsget_h", null ]
      ] ]
    ] ],
    [ "GRASS and the PROJ4 projection library", "projlib.html", [
      [ "GRASS and the PROJ4 projection library", "projlib.html#projintro", [
        [ "Datum transformation", "projlib.html#datum_transformation", null ],
        [ "Makefile Example", "projlib.html#Makefile_Example", null ]
      ] ],
      [ "Function", "projlib.html#Function", null ]
    ] ],
    [ "GRASS Python Scripting Library", "pythonlib.html", [
      [ "Introduction", "pythonlib.html#pythonIntro", null ],
      [ "GRASS scripting tasks for Python provided by \"grass.script\"", "pythonlib.html#pythonScripting", null ],
      [ "List of modules", "pythonlib.html#pythonModules", [
        [ "Core", "pythonlib.html#pythonCore", null ]
      ] ],
      [ "Database", "pythonlib.html#pythonDb", null ],
      [ "Raster", "pythonlib.html#pythonRaster", null ],
      [ "Vector", "pythonlib.html#pythonVector", null ],
      [ "Setup", "pythonlib.html#pythonSetup", null ],
      [ "Array", "pythonlib.html#pythonArray", null ],
      [ "Authors", "pythonlib.html#pythonAuthors", null ]
    ] ],
    [ "GRASS Raster Graphics Library", "rastergraphicslib.html", [
      [ "Connecting to the Driver", "rastergraphicslib.html#conn", null ],
      [ "Colors", "rastergraphicslib.html#col", null ],
      [ "Basic Graphics", "rastergraphicslib.html#basic", null ],
      [ "Poly Calls", "rastergraphicslib.html#poly", null ],
      [ "Raster Calls", "rastergraphicslib.html#raster", null ],
      [ "Text", "rastergraphicslib.html#text", null ],
      [ "GRASS font support", "rastergraphicslib.html#font", null ],
      [ "User Input", "rastergraphicslib.html#user", null ],
      [ "Loading the Raster Graphics Library", "rastergraphicslib.html#load", null ]
    ] ],
    [ "GRASS Segment Library", "segmentlib.html", [
      [ "Introduction", "segmentlib.html#segmentintro", null ],
      [ "Segment Routines", "segmentlib.html#Segment_Routines", null ],
      [ "How to Use the Library Routines", "segmentlib.html#How_to_Use_the_Library_Routines", null ],
      [ "Loading the Segment Library", "segmentlib.html#Loading_the_Segment_Library", null ]
    ] ],
    [ "Directed Graph Library", "dglib.html", [
      [ "Code Walk Through explanation", "dglib.html#codeWalkTrough", null ],
      [ "Functions", "dglib.html#functions", null ]
    ] ],
    [ "GRASS Network Analysis Library", "netalib.html", [
      [ "Functions", "netalib.html#netaFn", null ],
      [ "Authors", "netalib.html#netaAuthors", null ],
      [ "See Also", "netalib.html#netaSeeAlso", null ]
    ] ],
    [ "GRASS 6 Vector Architecture", "Vector_Library.html", [
      [ "Vector libraries", "Vector_Library.html#libraries", [
        [ "Introduction to Vlib (Vector library)", "Vector_Library.html#vlib", [
          [ "Directory structure", "Vector_Library.html#Directory_structure", null ],
          [ "Coor file format specification", "Vector_Library.html#coor_file_format_specification", null ],
          [ "Head file format", "Vector_Library.html#head_file_format", null ]
        ] ]
      ] ],
      [ "Vector library topology management", "Vector_Library.html#vlib_topology_management", [
        [ "Topology examples", "Vector_Library.html#vlib_topology_examples", null ],
        [ "Topo file format", "Vector_Library.html#topo_file_format", null ],
        [ "Topology Example 1:", "Vector_Library.html#Topology_Example_1", null ],
        [ "Topology Example 2:", "Vector_Library.html#Topology_Example_2", null ],
        [ "Topology Example 3:", "Vector_Library.html#Topology_Example_3", null ],
        [ "Topology Example 4:", "Vector_Library.html#Topology_Example_4", null ],
        [ "Topology memory management", "Vector_Library.html#vlib_topo_memory", null ]
      ] ],
      [ "Vector library spatial index management", "Vector_Library.html#vlib_spidx", null ],
      [ "Vector library categories and layers", "Vector_Library.html#vlib_categories_layers", null ],
      [ "Vector library category index", "Vector_Library.html#vlib_cidx", null ],
      [ "Vector TINs", "Vector_Library.html#vlibtin", null ],
      [ "Vector library and attributes", "Vector_Library.html#vlib_attributes", null ],
      [ "DGLib (Directed Graph Library)", "Vector_Library.html#grassdglib", null ],
      [ "Vector ASCII Format Specifications", "Vector_Library.html#vlibascii", null ],
      [ "Vector modules and their parameters/flags", "Vector_Library.html#vectmodules", [
        [ "Modules operation", "Vector_Library.html#vectmodulesoper", null ],
        [ "Modules parameters/flags", "Vector_Library.html#vectmodulesopt", null ]
      ] ],
      [ "List of vector library functions", "Vector_Library.html#vlibfunc", null ],
      [ "Vector area functions", "Vector_Library.html#area", null ],
      [ "Vector array functions", "Vector_Library.html#array", null ],
      [ "Vector bounding box functions", "Vector_Library.html#box", null ],
      [ "Vector break lines functions", "Vector_Library.html#break_lines", null ],
      [ "Vector break polygons functions", "Vector_Library.html#break_polygons", null ],
      [ "Vector bridges functions", "Vector_Library.html#bridges", null ],
      [ "Vector buffer functions", "Vector_Library.html#buffer", null ],
      [ "Vector build functions", "Vector_Library.html#build", [
        [ "Vector build (native) functions", "Vector_Library.html#build_nat", null ],
        [ "Vector build (OGR) functions", "Vector_Library.html#build_ogr", null ]
      ] ],
      [ "Vector categories functions", "Vector_Library.html#cats", null ],
      [ "Vector category index functions", "Vector_Library.html#cindex", null ],
      [ "Vector clean nodes functions", "Vector_Library.html#clean_nodes", null ],
      [ "Vector close functions", "Vector_Library.html#close", null ],
      [ "Vector constraint functions", "Vector_Library.html#constraint", null ],
      [ "Vector dangles functions", "Vector_Library.html#dangles", null ],
      [ "Vector dbcolumns functions", "Vector_Library.html#dbcolumns", null ],
      [ "Vector error functions", "Vector_Library.html#error", null ],
      [ "Vector field functions", "Vector_Library.html#field", null ],
      [ "Vector find functions", "Vector_Library.html#find", null ],
      [ "Vector graph functions", "Vector_Library.html#graph", null ],
      [ "Vector header functions", "Vector_Library.html#header", null ],
      [ "Vector history functions", "Vector_Library.html#hist", null ],
      [ "Vector header functions", "Vector_Library.html#init_head", null ],
      [ "Vector intersection functions", "Vector_Library.html#intersect", null ],
      [ "Vector valid map name functions", "Vector_Library.html#legal_vname", null ],
      [ "Vector level functions", "Vector_Library.html#level", null ],
      [ "Vector topological (level 2) functions", "Vector_Library.html#level_two", null ],
      [ "Vector feature functions", "Vector_Library.html#line", null ],
      [ "Vector list functions", "Vector_Library.html#list", null ],
      [ "Vector map functions", "Vector_Library.html#map", null ],
      [ "Vector network functions", "Vector_Library.html#net", null ],
      [ "Vector open functions", "Vector_Library.html#open", null ],
      [ "Vector overlay functions", "Vector_Library.html#overlay", null ],
      [ "Vector polygon functions", "Vector_Library.html#vpoly", null ],
      [ "Vector read functions", "Vector_Library.html#read", [
        [ "Level 1 and 2", "Vector_Library.html#read1_2", null ],
        [ "Level 2 only", "Vector_Library.html#read2", null ]
      ] ],
      [ "Vector remove areas functions", "Vector_Library.html#remove_areas", null ],
      [ "Vector remove duplicates functions", "Vector_Library.html#remove_duplicates", null ],
      [ "Vector rewind functions", "Vector_Library.html#rewind", null ],
      [ "Vector select functions", "Vector_Library.html#select", null ],
      [ "Vector spatial index functions", "Vector_Library.html#sindex", null ],
      [ "Vector snap functions", "Vector_Library.html#snap", null ],
      [ "Vector TIN functions", "Vector_Library.html#tin", null ],
      [ "Vector type option functions", "Vector_Library.html#type", null ],
      [ "Vector delete functions", "Vector_Library.html#delete", [
        [ "Level 2 only", "Vector_Library.html#delete2", null ]
      ] ],
      [ "Vector write functions", "Vector_Library.html#write", [
        [ "Level 1 and 2", "Vector_Library.html#write1_2", null ],
        [ "Level 2 only", "Vector_Library.html#write2", null ]
      ] ],
      [ "Authors", "Vector_Library.html#vlibAuthors", null ]
    ] ],
    [ "GRASS Vedit Library", "Vedit_Library.html", [
      [ "Introduction to Vedit Library", "Vedit_Library.html#veditIntro", null ],
      [ "Functions", "Vedit_Library.html#veditFn", [
        [ "Modify primitives", "Vedit_Library.html#veditModify", null ],
        [ "Manipulate feature categories", "Vedit_Library.html#veditCats", null ],
        [ "Copy primitives", "Vedit_Library.html#veditCopy", null ],
        [ "Select primitives", "Vedit_Library.html#veditSelect", null ],
        [ "Snapping", "Vedit_Library.html#veditSnap", null ],
        [ "Vertex manipulation", "Vedit_Library.html#veditVertex", null ],
        [ "Miscellaneous", "Vedit_Library.html#veditMisc", null ]
      ] ],
      [ "Authors", "Vedit_Library.html#authors", null ]
    ] ],
    [ "Todo List", "todo.html", null ],
    [ "Bug List", "bug.html", null ],
    [ "Namespaces", null, [
      [ "Namespace List", "namespaces.html", "namespaces" ],
      [ "Namespace Members", "namespacemembers.html", [
        [ "All", "namespacemembers.html", "namespacemembers_dup" ],
        [ "Functions", "namespacemembers_func.html", "namespacemembers_func" ],
        [ "Variables", "namespacemembers_vars.html", null ]
      ] ]
    ] ],
    [ "Data Structures", null, [
      [ "Data Structures", "annotated.html", "annotated" ],
      [ "Class Hierarchy", "hierarchy.html", "hierarchy" ],
      [ "Data Fields", "functions.html", [
        [ "All", "functions.html", "functions_dup" ],
        [ "Functions", "functions_func.html", "functions_func" ],
        [ "Variables", "functions_vars.html", "functions_vars" ],
        [ "Properties", "functions_prop.html", null ]
      ] ]
    ] ],
    [ "Files", null, [
      [ "File List", "files.html", "files" ],
      [ "Globals", "globals.html", [
        [ "All", "globals.html", "globals_dup" ],
        [ "Functions", "globals_func.html", "globals_func" ],
        [ "Variables", "globals_vars.html", "globals_vars" ],
        [ "Typedefs", "globals_type.html", null ],
        [ "Enumerations", "globals_enum.html", null ],
        [ "Enumerator", "globals_eval.html", null ],
        [ "Macros", "globals_defs.html", "globals_defs" ]
      ] ]
    ] ]
  ] ]
];

var NAVTREEINDEX =
[
"Bitmap_8c.html",
"GSX_8c.html#ae6dcc403b62680469baa14e0928eb1ef",
"N__gradient__calc_8c.html#a4e16f6e202f064584fb17380b8253e28",
"N__pde_8h.html#adc468db494f21aae806b6f395e275bd9",
"Vedit_Library.html#veditMisc",
"auto__mask_8c.html",
"c__finddb_8c.html",
"cairodriver_2Respond_8c.html",
"classbase_1_1BasePlotFrame.html#a4f5204f75d2ffea3eaa3bf4c32ddaf0b",
"classdialogs_1_1GdalImportDialog.html#a890f4059d14cf0c7a18ce052d7ce673c",
"classdialogs_1_1MapLayersDialog.html#ab681eb69c74bd042da2b35bdb422cb30",
"classdialogs_1_1RegionDef.html#a058074f915802b4e441efa31fff621c9",
"classdialogs_1_1VPropertiesDialog.html#a4f598f85c4a6a2a3d142f200d4dab6b8",
"classframe_1_1GMFrame.html#a302a71aa080598f77ced4c862a119167",
"classframe_1_1PsMapBufferedWindow.html#a2c6534b5877899192c47103e8094118d",
"classgis__set_1_1GRASSStartup.html#a5fffb9335c324689eee9050583dd93dc",
"classgselect_1_1LocationSelect.html#aee8ff24039b2b2ed8b805c0672407332",
"classinstructions_1_1Vector.html#a37119154528fe305fd23102670e5dc76",
"classmanager_1_1GCP.html#a968fb056767891a8225df993a3154882",
"classmapdisp_1_1MapFrameBase.html#a4f33dda3c4d64386f4246bba477d4557",
"classmapwindow_1_1GLWindow.html#acfc3f16e5035770b89876e561cf015d3",
"classmodel_1_1ModelObject.html#a7e60cc37214e10f0722d887ce4444697",
"classprofile_1_1ProfileFrame.html#ae96afe96e80253406d8d4e5f80334658",
"classsqlbuilder_1_1SQLFrame.html#af3e9b5f45c7f6cb0df24498f48a76826",
"classtoolbars_1_1VDigitToolbar.html#ae362f9a720cc7759f688359e3ad3a45f",
"classwizard_1_1DatumPage.html#a8497e1f8ea8a80cd6b2cfecf70937461",
"classwxdigit_1_1IVDigit.html#af55ea5d9c74e648dae362d906242d453",
"closecell_8c.html#ab640d6d2d0468382880879d2b26d96d1",
"com__proto_8c.html#a93fc757dbeb46224f543ccce673cc730",
"d__add__col_8c.html#a235aa432d1316ef6b7587e7aab12f6d7",
"dbfopen_8c.html#aa8cecfc5c5c054d2875c03e77b7be15d",
"dbstubs_8h_source.html",
"display_2window_8c_source.html",
"e__intersect_8h.html#a1dedeaeff47a3ee5620d70fd3d4936a5",
"fpcompress_8c.html#a1d6069090658864bfa3b943fed21cfbd",
"g3ddoubleio_8c.html",
"geodist_8c.html#a9a1ebbceb80581eb624d18561a62b9ed",
"gis_2zero_8c.html#addbcf923dff339fe0e64a73e007d5ddd",
"globals_8h.html#ad93b984ffeeefa3c539ae14588307480",
"graph_8h.html#a410636ff7148a3e1582d9d2b11dd265f",
"graph__v2_8h.html#a79199665b0b751e5722baa2823a41772",
"gsd__objs_8c.html#abeaa7fd7facdccc6aa66911df59fc583",
"gvl_8c.html#aa733335959f7c8f6a9e0801222ea156c",
"imagery_2alloc_8c.html#a4851cf56094d2efb1bf0d705e695d38f",
"level__two_8c.html",
"linkm_8c.html",
"map__obj_8c.html#a371b282a214cf302e195cfb4e4edf71e",
"namespacegrass_1_1script_1_1task.html",
"normp_8c.html",
"parser_8c.html#abe61014a12bf8958c89a4fa849ff2bef",
"points_8c.html",
"psdriver_2Respond_8c.html",
"quant_8c.html#af24ce2ea8f24cdddd590a7e3505e3c58",
"rgbpack_8h.html#a727bb97cb4391020514cbe97cb79e991",
"shapefil_8h.html#aed38ea97798142e2ae3ba74a0cf8f854",
"spindex__rw_8c.html#a499d30f0bdcd61d2dab89959443a045c",
"structN__data__star.html#abc4b6ed099dd8cfda8f084d1593a63b6",
"structSHPObject.html#a4e7797860f2abd0b9c724900698d400e",
"structdriver.html#a42bb6b0c4b42b171c364bebfde26e112",
"structrule.html#a60b328d693fbfdfefe45c2ffe9039ade",
"tavl_8h.html#ae28a74d728b332d4fc991006c966421b",
"tools_8py.html#a6a94b49d031d68b7bb35339f776dd8e4",
"tree_8c.html#a3ca73fca26cb31899588a4eaa3cd9809",
"v2-defs_8h.html#a6d717501108eafda5e977b8bd728711f",
"vector_2Vlib_2window_8c_source.html",
"wxpythonlib.html#gmodeler",
"y_8tab_8c.html#a9c7b069fee3c8184e14a7de8e5da2dc6"
];

var SYNCONMSG = 'click to disable panel synchronisation';
var SYNCOFFMSG = 'click to enable panel synchronisation';
var navTreeSubIndices = new Array();

function getData(varName)
{
  var i = varName.lastIndexOf('/');
  var n = i>=0 ? varName.substring(i+1) : varName;
  return eval(n.replace(/\-/g,'_'));
}

function stripPath(uri)
{
  return uri.substring(uri.lastIndexOf('/')+1);
}

function stripPath2(uri)
{
  var i = uri.lastIndexOf('/');
  var s = uri.substring(i+1);
  var m = uri.substring(0,i+1).match(/\/d\w\/d\w\w\/$/);
  return m ? uri.substring(i-6) : s;
}

function hashValue()
{
  return $(location).attr('hash').substring(1).replace(/[^\w\-]/g,'');
}

function hashUrl()
{
  return '#'+hashValue();
}

function pathName()
{
  return $(location).attr('pathname').replace(/[^-A-Za-z0-9+&@#/%?=~_|!:,.;\(\)]/g, '');
}

function localStorageSupported()
{
  try {
    return 'localStorage' in window && window['localStorage'] !== null && window.localStorage.getItem;
  }
  catch(e) {
    return false;
  }
}


function storeLink(link)
{
  if (!$("#nav-sync").hasClass('sync') && localStorageSupported()) {
      window.localStorage.setItem('navpath',link);
  }
}

function deleteLink()
{
  if (localStorageSupported()) {
    window.localStorage.setItem('navpath','');
  }
}

function cachedLink()
{
  if (localStorageSupported()) {
    return window.localStorage.getItem('navpath');
  } else {
    return '';
  }
}

function getScript(scriptName,func,show)
{
  var head = document.getElementsByTagName("head")[0]; 
  var script = document.createElement('script');
  script.id = scriptName;
  script.type = 'text/javascript';
  script.onload = func; 
  script.src = scriptName+'.js'; 
  if ($.browser.msie && $.browser.version<=8) { 
    // script.onload does not work with older versions of IE
    script.onreadystatechange = function() {
      if (script.readyState=='complete' || script.readyState=='loaded') { 
        func(); if (show) showRoot(); 
      }
    }
  }
  head.appendChild(script); 
}

function createIndent(o,domNode,node,level)
{
  var level=-1;
  var n = node;
  while (n.parentNode) { level++; n=n.parentNode; }
  if (node.childrenData) {
    var imgNode = document.createElement("img");
    imgNode.style.paddingLeft=(16*level).toString()+'px';
    imgNode.width  = 16;
    imgNode.height = 22;
    imgNode.border = 0;
    node.plus_img = imgNode;
    node.expandToggle = document.createElement("a");
    node.expandToggle.href = "javascript:void(0)";
    node.expandToggle.onclick = function() {
      if (node.expanded) {
        $(node.getChildrenUL()).slideUp("fast");
        node.plus_img.src = node.relpath+"ftv2pnode.png";
        node.expanded = false;
      } else {
        expandNode(o, node, false, false);
      }
    }
    node.expandToggle.appendChild(imgNode);
    domNode.appendChild(node.expandToggle);
    imgNode.src = node.relpath+"ftv2pnode.png";
  } else {
    var span = document.createElement("span");
    span.style.display = 'inline-block';
    span.style.width   = 16*(level+1)+'px';
    span.style.height  = '22px';
    span.innerHTML = '&#160;';
    domNode.appendChild(span);
  } 
}

var animationInProgress = false;

function gotoAnchor(anchor,aname,updateLocation)
{
  var pos, docContent = $('#doc-content');
  var ancParent = $(anchor.parent());
  if (ancParent.hasClass('memItemLeft') ||
      ancParent.hasClass('fieldname') ||
      ancParent.hasClass('fieldtype') ||
      ancParent.is(':header'))
  {
    pos = ancParent.position().top;
  } else if (anchor.position()) {
    pos = anchor.position().top;
  }
  if (pos) {
    var dist = Math.abs(Math.min(
               pos-docContent.offset().top,
               docContent[0].scrollHeight-
               docContent.height()-docContent.scrollTop()));
    animationInProgress=true;
    docContent.animate({
      scrollTop: pos + docContent.scrollTop() - docContent.offset().top
    },Math.max(50,Math.min(500,dist)),function(){
      if (updateLocation) window.location.href=aname;
      animationInProgress=false;
    });
  }
}

function newNode(o, po, text, link, childrenData, lastNode)
{
  var node = new Object();
  node.children = Array();
  node.childrenData = childrenData;
  node.depth = po.depth + 1;
  node.relpath = po.relpath;
  node.isLast = lastNode;

  node.li = document.createElement("li");
  po.getChildrenUL().appendChild(node.li);
  node.parentNode = po;

  node.itemDiv = document.createElement("div");
  node.itemDiv.className = "item";

  node.labelSpan = document.createElement("span");
  node.labelSpan.className = "label";

  createIndent(o,node.itemDiv,node,0);
  node.itemDiv.appendChild(node.labelSpan);
  node.li.appendChild(node.itemDiv);

  var a = document.createElement("a");
  node.labelSpan.appendChild(a);
  node.label = document.createTextNode(text);
  node.expanded = false;
  a.appendChild(node.label);
  if (link) {
    var url;
    if (link.substring(0,1)=='^') {
      url = link.substring(1);
      link = url;
    } else {
      url = node.relpath+link;
    }
    a.className = stripPath(link.replace('#',':'));
    if (link.indexOf('#')!=-1) {
      var aname = '#'+link.split('#')[1];
      var srcPage = stripPath(pathName());
      var targetPage = stripPath(link.split('#')[0]);
      a.href = srcPage!=targetPage ? url : "javascript:void(0)"; 
      a.onclick = function(){
        storeLink(link);
        if (!$(a).parent().parent().hasClass('selected'))
        {
          $('.item').removeClass('selected');
          $('.item').removeAttr('id');
          $(a).parent().parent().addClass('selected');
          $(a).parent().parent().attr('id','selected');
        }
        var anchor = $(aname);
        gotoAnchor(anchor,aname,true);
      };
    } else {
      a.href = url;
      a.onclick = function() { storeLink(link); }
    }
  } else {
    if (childrenData != null) 
    {
      a.className = "nolink";
      a.href = "javascript:void(0)";
      a.onclick = node.expandToggle.onclick;
    }
  }

  node.childrenUL = null;
  node.getChildrenUL = function() {
    if (!node.childrenUL) {
      node.childrenUL = document.createElement("ul");
      node.childrenUL.className = "children_ul";
      node.childrenUL.style.display = "none";
      node.li.appendChild(node.childrenUL);
    }
    return node.childrenUL;
  };

  return node;
}

function showRoot()
{
  var headerHeight = $("#top").height();
  var footerHeight = $("#nav-path").height();
  var windowHeight = $(window).height() - headerHeight - footerHeight;
  (function (){ // retry until we can scroll to the selected item
    try {
      var navtree=$('#nav-tree');
      navtree.scrollTo('#selected',0,{offset:-windowHeight/2});
    } catch (err) {
      setTimeout(arguments.callee, 0);
    }
  })();
}

function expandNode(o, node, imm, showRoot)
{
  if (node.childrenData && !node.expanded) {
    if (typeof(node.childrenData)==='string') {
      var varName    = node.childrenData;
      getScript(node.relpath+varName,function(){
        node.childrenData = getData(varName);
        expandNode(o, node, imm, showRoot);
      }, showRoot);
    } else {
      if (!node.childrenVisited) {
        getNode(o, node);
      } if (imm || ($.browser.msie && $.browser.version>8)) { 
        // somehow slideDown jumps to the start of tree for IE9 :-(
        $(node.getChildrenUL()).show();
      } else {
        $(node.getChildrenUL()).slideDown("fast");
      }
      if (node.isLast) {
        node.plus_img.src = node.relpath+"ftv2mlastnode.png";
      } else {
        node.plus_img.src = node.relpath+"ftv2mnode.png";
      }
      node.expanded = true;
    }
  }
}

function glowEffect(n,duration)
{
  n.addClass('glow').delay(duration).queue(function(next){
    $(this).removeClass('glow');next();
  });
}

function highlightAnchor()
{
  var aname = hashUrl();
  var anchor = $(aname);
  if (anchor.parent().attr('class')=='memItemLeft'){
    var rows = $('.memberdecls tr[class$="'+hashValue()+'"]');
    glowEffect(rows.children(),300); // member without details
  } else if (anchor.parent().attr('class')=='fieldname'){
    glowEffect(anchor.parent().parent(),1000); // enum value
  } else if (anchor.parent().attr('class')=='fieldtype'){
    glowEffect(anchor.parent().parent(),1000); // struct field
  } else if (anchor.parent().is(":header")) {
    glowEffect(anchor.parent(),1000); // section header
  } else {
    glowEffect(anchor.next(),1000); // normal member
  }
  gotoAnchor(anchor,aname,false);
}

function selectAndHighlight(hash,n)
{
  var a;
  if (hash) {
    var link=stripPath(pathName())+':'+hash.substring(1);
    a=$('.item a[class$="'+link+'"]');
  }
  if (a && a.length) {
    a.parent().parent().addClass('selected');
    a.parent().parent().attr('id','selected');
    highlightAnchor();
  } else if (n) {
    $(n.itemDiv).addClass('selected');
    $(n.itemDiv).attr('id','selected');
  }
  if ($('#nav-tree-contents .item:first').hasClass('selected')) {
    $('#nav-sync').css('top','30px');
  } else {
    $('#nav-sync').css('top','5px');
  }
  showRoot();
}

function showNode(o, node, index, hash)
{
  if (node && node.childrenData) {
    if (typeof(node.childrenData)==='string') {
      var varName    = node.childrenData;
      getScript(node.relpath+varName,function(){
        node.childrenData = getData(varName);
        showNode(o,node,index,hash);
      },true);
    } else {
      if (!node.childrenVisited) {
        getNode(o, node);
      }
      $(node.getChildrenUL()).css({'display':'block'});
      if (node.isLast) {
        node.plus_img.src = node.relpath+"ftv2mlastnode.png";
      } else {
        node.plus_img.src = node.relpath+"ftv2mnode.png";
      }
      node.expanded = true;
      var n = node.children[o.breadcrumbs[index]];
      if (index+1<o.breadcrumbs.length) {
        showNode(o,n,index+1,hash);
      } else {
        if (typeof(n.childrenData)==='string') {
          var varName = n.childrenData;
          getScript(n.relpath+varName,function(){
            n.childrenData = getData(varName);
            node.expanded=false;
            showNode(o,node,index,hash); // retry with child node expanded
          },true);
        } else {
          var rootBase = stripPath(o.toroot.replace(/\..+$/, ''));
          if (rootBase=="index" || rootBase=="pages" || rootBase=="search") {
            expandNode(o, n, true, true);
          }
          selectAndHighlight(hash,n);
        }
      }
    }
  } else {
    selectAndHighlight(hash);
  }
}

function removeToInsertLater(element) {
  var parentNode = element.parentNode;
  var nextSibling = element.nextSibling;
  parentNode.removeChild(element);
  return function() {
    if (nextSibling) {
      parentNode.insertBefore(element, nextSibling);
    } else {
      parentNode.appendChild(element);
    }
  };
}

function getNode(o, po)
{
  var insertFunction = removeToInsertLater(po.li);
  po.childrenVisited = true;
  var l = po.childrenData.length-1;
  for (var i in po.childrenData) {
    var nodeData = po.childrenData[i];
    po.children[i] = newNode(o, po, nodeData[0], nodeData[1], nodeData[2],
      i==l);
  }
  insertFunction();
}

function gotoNode(o,subIndex,root,hash,relpath)
{
  var nti = navTreeSubIndices[subIndex][root+hash];
  o.breadcrumbs = $.extend(true, [], nti ? nti : navTreeSubIndices[subIndex][root]);
  if (!o.breadcrumbs && root!=NAVTREE[0][1]) { // fallback: show index
    navTo(o,NAVTREE[0][1],"",relpath);
    $('.item').removeClass('selected');
    $('.item').removeAttr('id');
  }
  if (o.breadcrumbs) {
    o.breadcrumbs.unshift(0); // add 0 for root node
    showNode(o, o.node, 0, hash);
  }
}

function navTo(o,root,hash,relpath)
{
  var link = cachedLink();
  if (link) {
    var parts = link.split('#');
    root = parts[0];
    if (parts.length>1) hash = '#'+parts[1].replace(/[^\w\-]/g,'');
    else hash='';
  }
  if (hash.match(/^#l\d+$/)) {
    var anchor=$('a[name='+hash.substring(1)+']');
    glowEffect(anchor.parent(),1000); // line number
    hash=''; // strip line number anchors
  }
  var url=root+hash;
  var i=-1;
  while (NAVTREEINDEX[i+1]<=url) i++;
  if (i==-1) { i=0; root=NAVTREE[0][1]; } // fallback: show index
  if (navTreeSubIndices[i]) {
    gotoNode(o,i,root,hash,relpath)
  } else {
    getScript(relpath+'navtreeindex'+i,function(){
      navTreeSubIndices[i] = eval('NAVTREEINDEX'+i);
      if (navTreeSubIndices[i]) {
        gotoNode(o,i,root,hash,relpath);
      }
    },true);
  }
}

function showSyncOff(n,relpath)
{
    n.html('<img src="'+relpath+'sync_off.png" title="'+SYNCOFFMSG+'"/>');
}

function showSyncOn(n,relpath)
{
    n.html('<img src="'+relpath+'sync_on.png" title="'+SYNCONMSG+'"/>');
}

function toggleSyncButton(relpath)
{
  var navSync = $('#nav-sync');
  if (navSync.hasClass('sync')) {
    navSync.removeClass('sync');
    showSyncOff(navSync,relpath);
    storeLink(stripPath2(pathName())+hashUrl());
  } else {
    navSync.addClass('sync');
    showSyncOn(navSync,relpath);
    deleteLink();
  }
}

function initNavTree(toroot,relpath)
{
  var o = new Object();
  o.toroot = toroot;
  o.node = new Object();
  o.node.li = document.getElementById("nav-tree-contents");
  o.node.childrenData = NAVTREE;
  o.node.children = new Array();
  o.node.childrenUL = document.createElement("ul");
  o.node.getChildrenUL = function() { return o.node.childrenUL; };
  o.node.li.appendChild(o.node.childrenUL);
  o.node.depth = 0;
  o.node.relpath = relpath;
  o.node.expanded = false;
  o.node.isLast = true;
  o.node.plus_img = document.createElement("img");
  o.node.plus_img.src = relpath+"ftv2pnode.png";
  o.node.plus_img.width = 16;
  o.node.plus_img.height = 22;

  if (localStorageSupported()) {
    var navSync = $('#nav-sync');
    if (cachedLink()) {
      showSyncOff(navSync,relpath);
      navSync.removeClass('sync');
    } else {
      showSyncOn(navSync,relpath);
    }
    navSync.click(function(){ toggleSyncButton(relpath); });
  }

  $(window).load(function(){
    navTo(o,toroot,hashUrl(),relpath);
    showRoot();
  });

  $(window).bind('hashchange', function(){
     if (window.location.hash && window.location.hash.length>1){
       var a;
       if ($(location).attr('hash')){
         var clslink=stripPath(pathName())+':'+hashValue();
         a=$('.item a[class$="'+clslink.replace(/</g,'\\3c ')+'"]');
       }
       if (a==null || !$(a).parent().parent().hasClass('selected')){
         $('.item').removeClass('selected');
         $('.item').removeAttr('id');
       }
       var link=stripPath2(pathName());
       navTo(o,link,hashUrl(),relpath);
     } else if (!animationInProgress) {
       $('#doc-content').scrollTop(0);
       $('.item').removeClass('selected');
       $('.item').removeAttr('id');
       navTo(o,toroot,hashUrl(),relpath);
     }
  })
}

